##################################
### Whom.tcl                   ###
### Version 1.0                ###
### By Wcc                     ###
### wcc@techmonkeys.org        ###
### http://www.dawgtcl.com:81/ ###
### EFnet #|DAWG|Tcl           ###
##################################

############################################################################
### Copyright  2000 - 2002 |DAWG| Scripting Group. All rights reserved. ###
############################################################################

#############################################################################
## This script allows you to view the users on the partyline without using ##
## DCC chat.                                                               ##
#############################################################################

##############
## COMMANDS ##
############################################################
## MSG ## /msg <bot> whom <password> (Can be changed)     ##
######### Shows you the users currently on the partyline. ##
############################################################
## PUB ## !whom (Can be changed)                          ##
######### Shows you the users currently on the partyline. ##
############################################################

##########################################################
## Just load the script, edit the settings, and rehash. ##
##########################################################

#############################################################
# Set the flags required to use the script's commands here. #
#############################################################

set whom_settting(flags) "+o"

#############################
# Set the msg command here. #
#############################

set whom_settting(m_cmd) "whom"

#############################
# Set the pub command here. #
#############################

set whom_settting(p_cmd) "!whom"

####################
# Code begins here #
####################

if {![string match 1.6.* $version]} { putlog "\002WHOM:\002 \002WARNING:\002 This script is intended to run on eggdrop 1.6.x or later." }
if {[info tclversion] < 8.2} { putlog "\002WHOM:\002 \002WARNING:\002 This script is intended to run on Tcl Version 8.2 or later." }

bind msg $whom_settting(flags) $whom_settting(m_cmd) whom_msg
bind pub $whom_settting(flags) $whom_settting(p_cmd) whom_pub

proc whom_duration {idle} {
	set idle [duration [expr $idle * 60]]
	foreach {a b} {" years| year" "y" " weeks| week" "w" " days| day" "d" " hours| hour" "h" " minutes| minute" "m" " seconds| second" "s"} { regsub -all -- $a $idle $b idle }
	return [string trim $idle]
}
proc whom_msg {nick uhost hand text} {
	if {![validuser $hand]} { return }
	if {[string compare $text ""] == 0} { putserv "NOTICE $nick :Usage: /msg $::botnick whom <password>" ; return }
	if {![passwdok $hand [lindex [split $text] 0]]} { putserv "NOTICE $nick :Invalid password." ; return }
	foreach user [set whom [whom 0]] {
		set ctr 0
		foreach a [list hand bot host flag idle away] { set $a [lindex $user $ctr] ; incr ctr }
		putserv "NOTICE $nick :${flag}${hand}@${bot} ($host) [expr {($idle != 0) ? "\[idle: [whom_duration $idle]\]" : ""}] [expr {($away != "") ? "\[away: $away\]" : ""}]"
	}
	putserv "NOTICE $nick :Total: [llength $whom]"
}

proc whom_pub {nick uhost hand chan text} {
	foreach user [set whom [whom 0]] {
		set ctr 0
		foreach a [list hand bot host flag idle away] { set $a [lindex $user $ctr] ; incr ctr }
		putserv "PRIVMSG $chan :${flag}${hand}@${bot} ($host) [expr {($idle != 0) ? "\[idle: [whom_duration $idle]\]" : ""}] [expr {($away != "") ? "\[away: $away\]" : ""}]"
	}
	putserv "PRIVMSG $chan :Total: [llength $whom]"
}

putlog "\002WHOM:\002 Whom.tcl Version 1.0 by Wcc is loaded."
